Name:           wrk
Version:        4.2.0
Release:        1%{?dist}
Summary:        Modern HTTP benchmarking tool

License:        Apache-2.0 AND BSD-3-Clause AND MIT
# MIT: deps/openssl-1.1.1i.tar.gz src/ae_epoll.c src/ae_select.c src/zmalloc.c
# src/atomicvar.h src/ae_evport.c src/ae.c src/ae.h src/http_parser.c
# src/zmalloc.h src/ae_kqueue.c src/http_parser.h
# BSD: Makefile src/zmalloc.c src/config.h
URL:            https://github.com/wg/wrk
Source0:        %{url}/archive/%{version}/%{name}-%{version}.tar.gz

BuildRequires:  gcc
BuildRequires:  help2man
BuildRequires:  luajit-devel
BuildRequires:  make
BuildRequires:  openssl-devel

%description
wrk is a modern HTTP benchmarking tool capable of generating significant
load when run on a single multi-core CPU. It combines a multithreaded
design with scalable event notification systems such as epoll and kqueue.

An optional LuaJIT script can perform HTTP request generation, response
processing, and custom reporting.


%prep
%autosetup
# build against system libs
rm -rf deps
sed -i 's@-I$(WITH_LUAJIT)/include@`pkg-config --cflags luajit`@' Makefile
sed -i 's@-L$(WITH_LUAJIT)/lib@`pkg-config --libs luajit`@' Makefile
sed -i 's@-I$(WITH_OPENSSL)/include@`pkg-config --cflags openssl`@' Makefile
sed -i 's@-L$(WITH_OPENSSL)/lib@`pkg-config --cflags openssl`@' Makefile


%build
%make_build WITH_LUAJIT=SYS WITH_OPENSSL=SYS VER=%{version}


%install
%{__install} -Dpm0755 %{name} -t %{buildroot}%{_bindir}/
# example scripts from upstream
%{__install} -Dp scripts/* -t %{buildroot}%{_docdir}/%{name}/scripts/
# generate manpage from --help
mkdir -p %{buildroot}%{_mandir}/man1/
help2man %{buildroot}%{_bindir}/%{name} -o %{buildroot}%{_mandir}/man1/%{name}.1


%files
%license LICENSE
%doc README.md SCRIPTING CHANGES
%{_docdir}/%{name}/scripts/
%{_bindir}/%{name}
%{_mandir}/man1/%{name}.1*


%changelog
* Sat Aug 06 2022 Jonathan Wright <jonathan@almalinux.org> - 4.2.0-1
- Initial package build
